import Bladex
import Breakings
import Sparks
import Reference
import CharStats

PJ_DEF = [  0,  9,  19,  29 ]
PJ_ATT = [  0,  9,  19,  29  ]

PJ_CFG ={
	  "Knight_N":	[ ### C A B A L L E R O ###
	  			( ################## 1 ##################
	  				(### ESCUDOS ###
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Gladius",
	  					"Maza",
	  					"Orksword",
	  					"Espadaelfica",
	  				),### Life ###
	  				80,
	  			),
	  			( ################## 2 ##################
	  				(### ESCUDOS ###
	  					"Escudo2",
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Maza2",
	  					"Espadaromana",
	  					"Espadacurva",
	  				),### Life ###
	  				170,
	  			),
	  			( ################## 3 ##################
	  				(### ESCUDOS ###
	  					"Escudo2",
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Dagesse",
	  					"Cimitarra",
	  					"Maza3",
	  				),### Life ###
	  				340,
	  			),
	  			( ################## 4 ##################
	  				(### ESCUDOS ###
	  					"Escudo2",
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"EgyptSword",
	  					"Espadafilo",
	  					"Espada",
	  				),### Life ###
	  				680,
	  			),
	  		],
	  "Barbarian_N":	[ ### B A R B A R O ###
	  			( ################## 1 ##################
	  				(### ESCUDOS ###
	  					"Escudo2",
	  				),
	  				(### ESPADAS ###
	  					"Sablazo",
	  					"Chaosword",
	  					"DeathSword",
	  					"Eclipse",
	  				),### Life ###
	  				100,
	  			),
	  			( ################## 2 ##################
	  				(### ESCUDOS ###
	  				),
	  				(### ESPADAS ###
	  					"Guadanya",
	  					"LongSword",
	  					"Hacha2hojas",
	  				),### Life ###
	  				10,
	  			),
	  			( ################## 3 ##################
	  				(### ESCUDOS ###
	  				),
	  				(### ESPADAS ###
	  					"Alfanje",
	  					"RhinoClub",
	  					"BigSword",
	  				),### Life ###
	  				480,
	  			),
	  			( ################## 4 ##################
	  				(### ESCUDOS ###
	  				),
	  				(### ESPADAS ###
	  					"SawSword",
	  					"Hacharrajada",
	  					"FlatSword",
	  				),### Life ###
	  				860,
	  			),
	  		],
	  "Dwarf_N":	[ ### E N A N O ###	  
	  			( ################## 1 ##################
	  				(### ESCUDOS ###
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Garrote",
	  					"Hacha",
	  					"Hacha5",
	  					"Garropin",
	  				),### Life ###
	  				120,
	  			),
	  			( ################## 2 ##################
	  				(### ESCUDOS ###
	  					"Escudo2",
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Hacha4",
	  					"Hacha3",
	  					"Martillo",
	  				),### Life ###
	  				300,
	  			),
	  			( ################## 3 ##################
	  				(### ESCUDOS ###
	  					"Escudo2",
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Martillo2",
	  					"Garrote2",
	  					"MazaDoble",
	  				),### Life ###
	  				500,
	  			),
	  			( ################## 4 ##################
	  				(### ESCUDOS ###
	  					"Escudo2",
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Hacha6",
	  					"Hacha2",
	  					"Martillo3",
	  				),### Life ###
	  				760,
	  			),
	  		],
	  "Amazon_N":	[ ### A M A Z O N A ### 
	  			( ################## 1 ##################
	  				(### ESCUDOS ###
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Bo",
	  					"Chakram",
	  					"Katarmoon",
	  					"Lanza",
	  				),### Life ###
	  				70,
	  			),
	  			( ################## 2 ##################
	  				(### ESCUDOS ###
	  					"Escudo2",
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Chakram2",
	  					"Naginata",
	  					"Tridente",
	  				),### Life ###
	  				200,
	  			),
	  			( ################## 3 ##################
	  				(### ESCUDOS ###
	  					"Escudo2",
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Ninjato",
	  					"Katar",
	  					"Katana",
	  				),### Life ###
	  				400,
	  			),
	  			( ################## 4 ##################
	  				(### ESCUDOS ###
	  					"Escudo2",
	  					"Escudo1",
	  				),
	  				(### ESPADAS ###
	  					"Hachacuchilla",
	  					"DeathBo",
	  					"KatarDoble",
	  				),### Life ###
	  				700,
	  			),
	  		],
	}
	
def AddStandardWeapons2Char(EntityName,Typo="Knight",Handicap=4):

	ent = Bladex.GetEntity(EntityName)
	INV = ent.GetInventory()
	
	Weapons = PJ_CFG[Typo][Handicap-1][1]
	Shields = PJ_CFG[Typo][Handicap-1][0]

	First = 1
	for arma in Weapons:
		sword=Bladex.CreateEntity("xxx"+Bladex.GenerateEntityName(),arma,0,0,0)
		print arma
		swordName = sword.Name
		sword.Weapon=1
		Breakings.SetBreakableWS(swordName)
		flag=Reference.GiveWeaponFlag(swordName)
		INV.AddWeapon(swordName,flag)
		if First:
			INV.LinkRightHand(swordName)
			First = 0

	First = 1
	for arma in Shields:
		# Escudo redondo
		shield=Bladex.CreateEntity("xxx"+Bladex.GenerateEntityName(),arma,0,0,0)
		print arma
		shieldname = shield.Name
		Sparks.MakeShield(shieldname)
		Breakings.SetBreakableWS(shieldname)
		INV.AddShield(shieldname)
		if First:
			INV.LinkLeftHand(shieldname)
			First = 0
	ent.Level         = 29
	ent.Life          = PJ_CFG[Typo][Handicap-1][2]
	ent.Data.NetLevel = Handicap
	ent.Data.NetLife  = ent.Life

def GetDefense(Typo,Handicap):
	return CharStats.GetCharDefenseData(Typo,PJ_DEF[Handicap-1])

def GetDamage(Typo,Handicap):
	return CharStats.GetCharDamageData(Typo,PJ_ATT[Handicap-1])
